'Program		Fire
'Version		1.00
'Language		FreeBASIC 0.23 for Linux

'Copyright © 2012 David Watson [david@watzon.co.uk]

'Anyone is permitted to copy, modify, distribute and/or sell this program,
'provided that the copyright notice and permission notices appear in all copies.

'Anyone is permitted to use this program, provided that the user accepts that
'the program is provided "as is" and comes without any warranty.

'Anyone is permitted to integrate parts of the source code of this program into
'their own, provided that the author of this program is duly credited.



'######################### set up variables and screen #########################
dim as integer	b,c,x,y
dim as ubyte	bits(1023),heat(639,201)
dim as any ptr	fb

screen 18,8,,1							'fullscreen vga
setmouse ,,0							'hide the mouse
fb=screenptr+179200						'pointer to top of flames
randomize timer

'***************************** create fire palette *****************************
for c=0 to 63
	palette c,c							'black -> red
	palette c+63,(c shl 8) or &h3F		'red -> yellow
	palette c+126,(c shl 16) or &h3F3F	'yellow -> white
next c

'*************************** create random bitstream ***************************
for b=0 to 1023
	bits(b)=int(rnd*1.6)
next b

b=0

'********************** white hot layer below seeded fire **********************
for x=1 to 638
	heat(x,201)=189
next x



'################################## main loop ##################################
do
	screenlock

	'******************************** seed fire ********************************
	for x=1 to 638
		heat(x,200)=189-rnd*180
	next x

	'******************************* spread fire *******************************
	for y=0 to 199
		for x=1 to 638
			heat(x,y)=(heat(x,y+1)+heat(x-1,y+1)+heat(x+1,y+1)+heat(x,y+2)) shr 2
			if heat(x,y)>0 then
				heat(x,y)=heat(x,y)-bits(b)
				b=(b+1) and 1023
			endif
			poke ubyte,fb+y*640+x,heat(x,y)
		next x
	next y

	'******************************** finish up ********************************
	screenunlock
	sleep 10
	if inkey<>"" then end
loop

